=== modified file 'drizzled/optimizer/explain_plan.cc'
--- drizzled/optimizer/explain_plan.cc	2011-02-14 18:28:52 +0000
+++ drizzled/optimizer/explain_plan.cc	2011-02-16 05:06:35 +0000
@@ -75,7 +75,6 @@
 
 void optimizer::ExplainPlan::printPlan()
 {
-  List<Item> field_list;
   List<Item> item_list;
   Session *session= join->session;
   select_result *result= join->result;
@@ -182,18 +181,12 @@
     {
       JoinTable *tab= join->join_tab + i;
       Table *table= tab->table;
-      char buff[512];
-      char buff1[512], buff2[512], buff3[512];
       char keylen_str_buf[64];
-      String extra(buff, sizeof(buff),cs);
+      string extra;
       char table_name_buffer[NAME_LEN];
-      String tmp1(buff1,sizeof(buff1),cs);
-      String tmp2(buff2,sizeof(buff2),cs);
-      String tmp3(buff3,sizeof(buff3),cs);
-      extra.length(0);
-      tmp1.length(0);
-      tmp2.length(0);
-      tmp3.length(0);
+      string tmp1;
+      string tmp2;
+      string tmp3;
 
       quick_type= -1;
       item_list.empty();
@@ -243,15 +236,14 @@
           if (tab->keys.test(j))
           {
             if (tmp1.length())
-              tmp1.append(',');
+              tmp1.append(",");
             tmp1.append(table->key_info[j].name,
-                        strlen(table->key_info[j].name),
-                        system_charset_info);
+                        strlen(table->key_info[j].name));
           }
         }
       }
       if (tmp1.length())
-        item_list.push_back(new Item_string(tmp1.ptr(),tmp1.length(),cs));
+        item_list.push_back(new Item_string(tmp1.c_str(),tmp1.length(),cs));
       else
         item_list.push_back(item_null);
 
@@ -270,12 +262,11 @@
         for (StoredKey **ref= tab->ref.key_copy; *ref; ref++)
         {
           if (tmp2.length())
-            tmp2.append(',');
-          tmp2.append((*ref)->name(), 
-                       strlen((*ref)->name()),
-                       system_charset_info);
+            tmp2.append(",");
+          tmp2.append((*ref)->name(),
+                      strlen((*ref)->name()));
         }
-        item_list.push_back(new Item_string(tmp2.ptr(),tmp2.length(),cs));
+        item_list.push_back(new Item_string(tmp2.c_str(),tmp2.length(),cs));
       }
       else if (tab->type == AM_NEXT)
       {
@@ -292,8 +283,8 @@
       else if (tab->select && tab->select->quick)
       {
         tab->select->quick->add_keys_and_lengths(&tmp2, &tmp3);
-        item_list.push_back(new Item_string(tmp2.ptr(),tmp2.length(),cs));
-        item_list.push_back(new Item_string(tmp3.ptr(),tmp3.length(),cs));
+        item_list.push_back(new Item_string(tmp2.c_str(),tmp2.length(),cs));
+        item_list.push_back(new Item_string(tmp3.c_str(),tmp3.length(),cs));
         item_list.push_back(item_null);
       }
       else
@@ -348,20 +339,14 @@
       else if (tab->packed_info & TAB_INFO_HAVE_VALUE)
       {
         if (tab->packed_info & TAB_INFO_USING_INDEX)
-          extra.append(STRING_WITH_LEN("; Using index"));
+          extra.append("; Using index");
         if (tab->packed_info & TAB_INFO_USING_WHERE)
-          extra.append(STRING_WITH_LEN("; Using where"));
+          extra.append("; Using where");
         if (tab->packed_info & TAB_INFO_FULL_SCAN_ON_NULL)
-          extra.append(STRING_WITH_LEN("; Full scan on NULL key"));
-        /* Skip initial "; "*/
-        const char *str= extra.ptr();
-        uint32_t len= extra.length();
-        if (len)
-        {
-          str += 2;
-          len -= 2;
-        }
-        item_list.push_back(new Item_string(str, len, cs));
+          extra.append("; Full scan on NULL key");
+        if (extra.length())
+          extra.erase(0, 2);        /* Skip initial "; "*/
+        item_list.push_back(new Item_string(extra.c_str(), extra.length(), cs));
       }
       else
       {
@@ -375,7 +360,7 @@
             quick_type == optimizer::QuickSelectInterface::QS_TYPE_ROR_INTERSECT ||
             quick_type == optimizer::QuickSelectInterface::QS_TYPE_INDEX_MERGE)
         {
-          extra.append(STRING_WITH_LEN("; Using "));
+          extra.append("; Using ");
           tab->select->quick->add_info_string(&extra);
         }
         if (tab->select)
@@ -400,65 +385,58 @@
               if (tmp.any())
                 s << uppercase << hex << tmp.to_ulong();
             }
-            extra.append(STRING_WITH_LEN("; Range checked for each "
-                  "record (index map: 0x"));
+            extra.append("; Range checked for each record (index map: 0x");
             extra.append(s.str().c_str());
-            extra.append(')');
+            extra.append(")");
           }
           else if (tab->select->cond)
           {
-            extra.append(STRING_WITH_LEN("; Using where"));
+            extra.append("; Using where");
           }
         }
         if (key_read)
         {
           if (quick_type == optimizer::QuickSelectInterface::QS_TYPE_GROUP_MIN_MAX)
-            extra.append(STRING_WITH_LEN("; Using index for group-by"));
+            extra.append("; Using index for group-by");
           else
-            extra.append(STRING_WITH_LEN("; Using index"));
+            extra.append("; Using index");
         }
         if (table->reginfo.not_exists_optimize)
-          extra.append(STRING_WITH_LEN("; Not exists"));
+          extra.append("; Not exists");
 
         if (need_tmp_table)
         {
           need_tmp_table=0;
-          extra.append(STRING_WITH_LEN("; Using temporary"));
+          extra.append("; Using temporary");
         }
         if (need_order)
         {
           need_order=0;
-          extra.append(STRING_WITH_LEN("; Using filesort"));
+          extra.append("; Using filesort");
         }
         if (distinct & test_all_bits(used_tables,session->used_tables))
-          extra.append(STRING_WITH_LEN("; Distinct"));
+          extra.append("; Distinct");
 
         if (tab->insideout_match_tab)
         {
-          extra.append(STRING_WITH_LEN("; LooseScan"));
+          extra.append("; LooseScan");
         }
 
         for (uint32_t part= 0; part < tab->ref.key_parts; part++)
         {
           if (tab->ref.cond_guards[part])
           {
-            extra.append(STRING_WITH_LEN("; Full scan on NULL key"));
+            extra.append("; Full scan on NULL key");
             break;
           }
         }
 
         if (i > 0 && tab[-1].next_select == sub_select_cache)
-          extra.append(STRING_WITH_LEN("; Using join buffer"));
+          extra.append("; Using join buffer");
 
-        /* Skip initial "; "*/
-        const char *str= extra.ptr();
-        uint32_t len= extra.length();
-        if (len)
-        {
-          str += 2;
-          len -= 2;
-        }
-        item_list.push_back(new Item_string(str, len, cs));
+        if (extra.length())
+          extra.erase(0, 2);
+        item_list.push_back(new Item_string(extra.c_str(), extra.length(), cs));
       }
       // For next iteration
       used_tables|=table->map;

=== modified file 'drizzled/optimizer/quick_group_min_max_select.cc'
--- drizzled/optimizer/quick_group_min_max_select.cc	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_group_min_max_select.cc	2011-02-16 04:22:54 +0000
@@ -737,8 +737,8 @@
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::add_keys_and_lengths(String *key_names,
-                                                             String *used_lengths)
+void optimizer::QuickGroupMinMaxSelect::add_keys_and_lengths(string *key_names,
+                                                             string *used_lengths)
 {
   char buf[64];
   key_names->append(index_info->name);

=== modified file 'drizzled/optimizer/quick_group_min_max_select.h'
--- drizzled/optimizer/quick_group_min_max_select.h	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_group_min_max_select.h	2011-02-16 04:22:54 +0000
@@ -450,7 +450,7 @@
    * This method is used by select_describe to extract the names of the
    * indexes used by a quick select.
    */
-  void add_keys_and_lengths(String *key_names, String *used_lengths);
+  void add_keys_and_lengths(std::string *key_names, std::string *used_lengths);
 
 };
 

=== modified file 'drizzled/optimizer/quick_index_merge_select.cc'
--- drizzled/optimizer/quick_index_merge_select.cc	2011-02-14 05:47:07 +0000
+++ drizzled/optimizer/quick_index_merge_select.cc	2011-02-16 05:06:35 +0000
@@ -227,31 +227,31 @@
 }
 
 
-void optimizer::QuickIndexMergeSelect::add_info_string(String *str)
+void optimizer::QuickIndexMergeSelect::add_info_string(string *str)
 {
   bool first= true;
-  str->append(STRING_WITH_LEN("sort_union("));
+  str->append("sort_union(");
   for (vector<optimizer::QuickRangeSelect *>::iterator it= quick_selects.begin();
        it != quick_selects.end();
        ++it)
   {
     if (! first)
-      str->append(',');
+      str->append(",");
     else
       first= false;
     (*it)->add_info_string(str);
   }
   if (pk_quick_select)
   {
-    str->append(',');
+    str->append(",");
     pk_quick_select->add_info_string(str);
   }
-  str->append(')');
+  str->append(")");
 }
 
 
-void optimizer::QuickIndexMergeSelect::add_keys_and_lengths(String *key_names,
-                                                            String *used_lengths)
+void optimizer::QuickIndexMergeSelect::add_keys_and_lengths(string *key_names,
+                                                            string *used_lengths)
 {
   char buf[64];
   uint32_t length= 0;
@@ -265,8 +265,8 @@
       first= false;
     else
     {
-      key_names->append(',');
-      used_lengths->append(',');
+      key_names->append(",");
+      used_lengths->append(",");
     }
 
     KeyInfo *key_info= head->key_info + (*it)->index;
@@ -277,10 +277,10 @@
   if (pk_quick_select)
   {
     KeyInfo *key_info= head->key_info + pk_quick_select->index;
-    key_names->append(',');
+    key_names->append(",");
     key_names->append(key_info->name);
     length= internal::int64_t2str(pk_quick_select->max_used_key_length, buf, 10) - buf;
-    used_lengths->append(',');
+    used_lengths->append(",");
     used_lengths->append(buf, length);
   }
 }

=== modified file 'drizzled/optimizer/quick_index_merge_select.h'
--- drizzled/optimizer/quick_index_merge_select.h	2011-02-09 22:48:12 +0000
+++ drizzled/optimizer/quick_index_merge_select.h	2011-02-16 05:06:35 +0000
@@ -126,8 +126,8 @@
     return QS_TYPE_INDEX_MERGE;
   }
 
-  void add_keys_and_lengths(String *key_names, String *used_lengths);
-  void add_info_string(String *str);
+  void add_keys_and_lengths(std::string *key_names, std::string *used_lengths);
+  void add_info_string(std::string *str);
   bool is_keys_used(const boost::dynamic_bitset<>& fields);
 
   bool push_quick_back(QuickRangeSelect *quick_sel_range);

=== modified file 'drizzled/optimizer/quick_range_select.cc'
--- drizzled/optimizer/quick_range_select.cc	2011-02-14 05:47:07 +0000
+++ drizzled/optimizer/quick_range_select.cc	2011-02-16 05:06:35 +0000
@@ -419,15 +419,15 @@
 }
 
 
-void optimizer::QuickRangeSelect::add_info_string(String *str)
+void optimizer::QuickRangeSelect::add_info_string(string *str)
 {
   KeyInfo *key_info= head->key_info + index;
   str->append(key_info->name);
 }
 
 
-void optimizer::QuickRangeSelect::add_keys_and_lengths(String *key_names,
-                                                       String *used_lengths)
+void optimizer::QuickRangeSelect::add_keys_and_lengths(string *key_names,
+                                                       string *used_lengths)
 {
   char buf[64];
   uint32_t length;

=== modified file 'drizzled/optimizer/quick_range_select.h'
--- drizzled/optimizer/quick_range_select.h	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_range_select.h	2011-02-16 05:06:35 +0000
@@ -203,9 +203,9 @@
     return QS_TYPE_RANGE;
   }
 
-  void add_keys_and_lengths(String *key_names, String *used_lengths);
+  void add_keys_and_lengths(std::string *key_names, std::string *used_lengths);
 
-  void add_info_string(String *str);
+  void add_info_string(std::string *str);
 
   void resetCursor()
   {

=== modified file 'drizzled/optimizer/quick_ror_intersect_select.cc'
--- drizzled/optimizer/quick_ror_intersect_select.cc	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_ror_intersect_select.cc	2011-02-16 05:06:35 +0000
@@ -246,17 +246,17 @@
 }
 
 
-void optimizer::QuickRorIntersectSelect::add_info_string(String *str)
+void optimizer::QuickRorIntersectSelect::add_info_string(string *str)
 {
   bool first= true;
-  str->append(STRING_WITH_LEN("intersect("));
+  str->append("intersect(");
   for (vector<optimizer::QuickRangeSelect *>::iterator it= quick_selects.begin();
        it != quick_selects.end();
        ++it)
   {
     KeyInfo *key_info= head->key_info + (*it)->index;
     if (! first)
-      str->append(',');
+      str->append(",");
     else
       first= false;
     str->append(key_info->name);
@@ -264,15 +264,15 @@
   if (cpk_quick)
   {
     KeyInfo *key_info= head->key_info + cpk_quick->index;
-    str->append(',');
+    str->append(",");
     str->append(key_info->name);
   }
-  str->append(')');
+  str->append(")");
 }
 
 
-void optimizer::QuickRorIntersectSelect::add_keys_and_lengths(String *key_names,
-                                                              String *used_lengths)
+void optimizer::QuickRorIntersectSelect::add_keys_and_lengths(string *key_names,
+                                                              string *used_lengths)
 {
   char buf[64];
   uint32_t length;
@@ -288,8 +288,8 @@
     }
     else
     {
-      key_names->append(',');
-      used_lengths->append(',');
+      key_names->append(",");
+      used_lengths->append(",");
     }
     key_names->append(key_info->name);
     length= internal::int64_t2str((*it)->max_used_key_length, buf, 10) - buf;
@@ -299,10 +299,10 @@
   if (cpk_quick)
   {
     KeyInfo *key_info= head->key_info + cpk_quick->index;
-    key_names->append(',');
+    key_names->append(",");
     key_names->append(key_info->name);
     length= internal::int64_t2str(cpk_quick->max_used_key_length, buf, 10) - buf;
-    used_lengths->append(',');
+    used_lengths->append(",");
     used_lengths->append(buf, length);
   }
 }

=== modified file 'drizzled/optimizer/quick_ror_intersect_select.h'
--- drizzled/optimizer/quick_ror_intersect_select.h	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_ror_intersect_select.h	2011-02-16 05:06:35 +0000
@@ -116,8 +116,8 @@
     return QS_TYPE_ROR_INTERSECT;
   }
 
-  void add_keys_and_lengths(String *key_names, String *used_lengths);
-  void add_info_string(String *str);
+  void add_keys_and_lengths(std::string *key_names, std::string *used_lengths);
+  void add_info_string(std::string *str);
   bool is_keys_used(const boost::dynamic_bitset<>& fields);
 
   /**

=== modified file 'drizzled/optimizer/quick_ror_union_select.cc'
--- drizzled/optimizer/quick_ror_union_select.cc	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_ror_union_select.cc	2011-02-16 05:06:35 +0000
@@ -230,26 +230,26 @@
 }
 
 
-void optimizer::QuickRorUnionSelect::add_info_string(String *str)
+void optimizer::QuickRorUnionSelect::add_info_string(string *str)
 {
   bool first= true;
-  str->append(STRING_WITH_LEN("union("));
+  str->append("union(");
   for (vector<optimizer::QuickSelectInterface *>::iterator it= quick_selects.begin();
        it != quick_selects.end();
        ++it)
   {
     if (! first)
-      str->append(',');
+      str->append(",");
     else
       first= false;
     (*it)->add_info_string(str);
   }
-  str->append(')');
+  str->append(")");
 }
 
 
-void optimizer::QuickRorUnionSelect::add_keys_and_lengths(String *key_names,
-                                                          String *used_lengths)
+void optimizer::QuickRorUnionSelect::add_keys_and_lengths(string *key_names,
+                                                          string *used_lengths)
 {
   bool first= true;
   for (vector<optimizer::QuickSelectInterface *>::iterator it= quick_selects.begin();
@@ -262,8 +262,8 @@
     }
     else
     {
-      used_lengths->append(',');
-      key_names->append(',');
+      used_lengths->append(",");
+      key_names->append(",");
     }
     (*it)->add_keys_and_lengths(key_names, used_lengths);
   }

=== modified file 'drizzled/optimizer/quick_ror_union_select.h'
--- drizzled/optimizer/quick_ror_union_select.h	2010-12-18 04:43:40 +0000
+++ drizzled/optimizer/quick_ror_union_select.h	2011-02-16 05:06:35 +0000
@@ -103,8 +103,8 @@
     return QS_TYPE_ROR_UNION;
   }
 
-  void add_keys_and_lengths(String *key_names, String *used_lengths);
-  void add_info_string(String *str);
+  void add_keys_and_lengths(std::string *key_names, std::string *used_lengths);
+  void add_info_string(std::string *str);
   bool is_keys_used(const boost::dynamic_bitset<>& fields);
 
   bool push_quick_back(QuickSelectInterface *quick_sel_range);

=== modified file 'drizzled/optimizer/range.h'
--- drizzled/optimizer/range.h	2011-02-11 21:34:53 +0000
+++ drizzled/optimizer/range.h	2011-02-16 05:06:35 +0000
@@ -241,7 +241,8 @@
    * 
    * @note This is used by during explain plan.
    */
-  virtual void add_keys_and_lengths(String *key_names, String *used_lengths)=0;
+  virtual void add_keys_and_lengths(std::string *key_names,
+                                    std::string *used_lengths)=0;
 
   /**
    * Append text representation of quick select structure (what and how is
@@ -252,9 +253,9 @@
    * This function is implemented only by quick selects that merge other quick
    * selects output and/or can produce output suitable for merging.
    */
-  virtual void add_info_string(String *) 
+  virtual void add_info_string(std::string *)
   {}
-  
+
   /**
    * Returns true if any index used by this quick select
    * uses field which is marked in passed bitmap.

